extends GridContainer

onready var wood_label = $WoodAmount
onready var leather_label = $LeatherAmount
onready var steel_label = $SteelAmount

onready var wood_preview = $WoodPreview
onready var leather_pewview = $LeatherPreview
onready var steel_preview = $SteelPreview

var resources = {
	"wood": 0,
	"leather": 0,
	"steel": 0
}

func _ready():
	GameManager.RESOURCES_MANAGER = self

func add_resource(key : String, amount: int):
	resources[key] += amount
	update_labels()
func remove_resource(key : String, amount: int):
	resources[key] -= amount
	update_labels()
func preview_changes(values : Array, _sign : int):
	if values[0] == 0 and values[1] == 0 and values[2] == 0:
		return
	var s = "+" if _sign > 0 else "-"
	wood_preview.text = s + str(values[0])
	leather_pewview.text = s + str(values[1])
	steel_preview.text = s + str(values[2])

func stop_previews():
	wood_preview.text = ""
	leather_pewview.text = ""
	steel_preview.text = ""
	pass
func update_labels():
	wood_label.text = str(resources["wood"])
	leather_label.text = str(resources["leather"])
	steel_label.text = str(resources["steel"])
