extends GridContainer

var resources_names = [ "wood", "leather", "steel" ]

func _DismantleButton_pressed():
	pass

func _on_DismantleButton_mouse_entered():
	if Hand.holded_card != null:
		var data = CardsData.CARDS[Hand.holded_card.card_key]
		GameManager.RESOURCES_MANAGER.preview_changes(data.dismantle_resources,1)

func _on_DismantleButton_mouse_exited():
	GameManager.RESOURCES_MANAGER.stop_previews()

func RepairButton_pressed():
	if Hand.holded_card != null:
		var is_broken = Hand.holded_card.card_key.find("-broken") == -1
		if is_broken:
			SFXManager.play_sfx("error")
			return
		var new_card = Hand.holded_card.card_key.rstrip("-broken")
		var data = CardsData.CARDS[Hand.holded_card.card_key]
		if GameManager.RESOURCES_MANAGER.resources["wood"] < data.repair_resources[0]:
			return
		if GameManager.RESOURCES_MANAGER.resources["leather"] < data.repair_resources[1]:
			return
		if GameManager.RESOURCES_MANAGER.resources["steel"] < data.repair_resources[2]:
			return
		
		
		for i in range(data.repair_resources.size()):
			GameManager.RESOURCES_MANAGER.remove_resource(resources_names[i],data.repair_resources[i])
			
		print(new_card)
		Hand.destroy_holded_card()
		GameManager.RESOURCES_MANAGER.stop_previews()
		GameManager.DECK.add_card_by_id(new_card)
		GameManager.DECK.reajust_cards()
	pass # Replace with function body.

func _on_RepairButton_mouse_entered():
	if Hand.holded_card != null:
		var data = CardsData.CARDS[Hand.holded_card.card_key]
		GameManager.RESOURCES_MANAGER.preview_changes(data.repair_resources,-1)

func _on_RepairButton_mouse_exited():
	GameManager.RESOURCES_MANAGER.stop_previews()


func _on_RepairButton_button_up():
	pass


func _on_DismantleButton_button_up():
	pass



func _on_DismantleButton_pressed():
	if Hand.holded_card != null:
		var data = CardsData.CARDS[Hand.holded_card.card_key]
		for i in range(data.dismantle_resources.size()):
			GameManager.RESOURCES_MANAGER.add_resource(resources_names[i],data.dismantle_resources[i])
		
		Hand.destroy_holded_card()
		GameManager.RESOURCES_MANAGER.stop_previews()
		GameManager.DECK.reajust_cards()
