extends Control

onready var image_texture = $Pivot/Image
onready var title_label = $Pivot/Title
onready var description_label = $Pivot/Description
onready var animation_player = $AnimationPlayer
onready var arrow_line = $Node/ArrowLine
onready var arrow_end = $Node/ArrowEnd

var last_z_value  = 0
var selected = false
var card_key

func set_data(_card_key):
	self.card_key = _card_key
	var data = CardsData.CARDS[card_key]
	image_texture.texture = data.image
	title_label.text = data.title
	
	description_label.text = "Attack: %s\nDefense: %s" % [data.attack,data.defense]
	
	

func _ready():
	animation_player.play("Spawn")

func _process(delta):
	if selected:
		arrow_line.points[0] = rect_global_position + rect_size/2
		arrow_line.points[1] = get_global_mouse_position()
		arrow_end.global_position = get_global_mouse_position()
		
		
func mouse_entered():
	last_z_value = get_index()
	get_parent().move_child(self,get_parent().get_child_count()-1)
	if !dest:
		animation_player.play("Touched")


func mouse_exited():
	get_parent().move_child(self,last_z_value)
	if !dest:
		animation_player.play("Released")

func deselect():
	set_selection(false)
func rearrange():
	pass
func set_selection(value):
	selected = value
	arrow_line.visible = selected
	arrow_end.visible = selected
	if selected:
		Hand.holded_card = self
	else:
		Hand.holded_card = null
func pressed():
	
	pass
var dest = false
func destroy():
	dest = true
	animation_player.play("Destroy")
	var index = GameManager.DECK.current_cards.find(self)
	if index != -1:
		GameManager.DECK.current_cards.remove()
		
	yield(get_tree().create_timer(0.1),"timeout")
	deselect()
func free_card():
	queue_free()


func _on_Button_button_down():
	var previous_state = selected
	GameManager.DECK.deselect_all_cards()
	set_selection(!previous_state)
	pass # Replace with function body.


func _on_Button_button_up():
	pass # Replace with function body.
