extends Control

export(PackedScene) var card_resource

var current_cards = []
func _ready():
	GameManager.DECK = self
	yield(get_tree().create_timer(1),"timeout")
	for i in range(3):
		add_card(CardsData.get_random_broken_card_data())

#func _input(event):
#	if event is InputEventKey:
#		if event.pressed:
#			if event.scancode == KEY_C:
#				add_card(CardsData.get_random_card_data())
#			if event.scancode == KEY_F:
#				remove_all_cards()
#			if event.scancode == KEY_P:
#				GameManager.PROGRESS_BAR.set_progress(100)
func add_card_by_id(id):
	if current_cards.size() >= 7:
		return
	var instance = card_resource.instance()
	add_child(instance)
	instance.set_data(id)
	current_cards.append(instance)
	reajust_cards()
func add_random_card():
	var random_id = CardsData.CARDS.keys()[rand_range(0,CardsData.CARDS.keys().size())]
	add_card_by_id(random_id)
	pass
func add_random_broken_card():
	var random_id = CardsData.CARDS.keys()[rand_range(0,CardsData.CARDS.keys().size()-2)]
	add_card_by_id(random_id)
	pass
func add_card(card_data : CardsData.Card):
	if current_cards.size() >= 7:
		return
	var instance = card_resource.instance()
	add_child(instance)
	instance.set_data(CardsData.get_random_card_data())
	current_cards.append(instance)
	reajust_cards()
		
func reajust_cards():
	#Position Adjustment
	var count = current_cards.size()
	var i = 0
	for card in current_cards:
		#center
		card.rect_position.x = rect_position.x 
		card.rect_position.y = rect_position.y - card.rect_size.y/4 + 100
		#offset
		if count > 1:
			var delta = range_lerp(float(i), 0.0, float(count-1), 0.0, 1.0)#1.0/(count-1.0 + (2 if count == 2 else 0)) * i
			print(delta)
			card.rect_position.x -= lerp(-count/2,count/2,delta) * 125
#			card.rect_position.x += card.rect_size.x/2 * i + 100
			card.rect_rotation = cos(delta*PI)*(count+PI*4)
			i += 1
			card.rearrange()
	pass
func remove_all_cards():
	while(current_cards.size() > 0):
		current_cards[0].queue_free()
		current_cards.remove(0)
	Hand.destroy_holded_card()
func remove_card():
	pass

func deselect_all_cards():
	for card in current_cards:
		card.deselect()
