extends Node2D

enum spawner_type {Player, Enemy}
export(spawner_type) var type
onready var unit_resource = preload("res://Scenes/Unit.tscn")
onready var end_node = $End
export(float) var delay = 2

var units = []

func _enter_tree():
	randomize()
	spawning_routine()
func _ready():
	
	pass
func spawning_routine():
	yield(get_tree().create_timer(rand_range(1,15)),"timeout")
	while true:
		if GameManager.ended:
			return
		spawn()
		yield(get_tree().create_timer(rand_range(delay,delay+2)),"timeout")
func spawn():
	var instance = unit_resource.instance()
	get_tree().root.get_node("/root/World").add_child(instance)
	instance.spawn(global_position, end_node.global_position, "enemy" if type == spawner_type.Enemy else "player")
	units.push_front(instance)
	instance.spawner = self

func pop_unit(instance):
	var index = units.find(instance)
	if index != -1:
		units.remove(index)

func add_stats_front_unit(attack, defense, weapon):
	var index = rand_range(0,units.size())
	units[index].add_stats(attack, defense)
	if !weapon.empty():
		units[index].change_weapon(weapon)
	pass
